/******************************************************************************
|Project	|Windows9x/NT/2000 ScreenServer skelton project
|Copyright	|Copyright(C)1997-1999,2000 Scope,Kazuhiko Watanabe
|			|mailto:scope@mx5.et.tiki.ne.jp
|			|http://ww5.et.tiki.ne.jp/~scope/
|-----------+---------------+--------------------------------------------------
|content	|XN[Z[o[TChI
|			|Microsoft Visual C/C++6.0
|			|necessary "SCRNSAVE.LIB" with "WINMM.LIB" Liblary
|-----------+---------------+--------------------------------------------------
|Renewal	|1997/10/09		Kazuhiko Watanabe
|			|1999/05/24		Version up
|			|2000/05/20		W2K renew,MSVC6.0 convert
|			|20--/--/--		-
|			|20--/--/--		-
|			|20--/--/--		-
|			|20--/--/--		-
|			|20--/--/--		-
******************************************************************************/
#include	<windows.h>
#include	<scrnsave.h>
#include	<math.h>
//
#include	"resource.h"
#include	"main.h"
#include	"app.h"
#include	"ver.h"
#include	"util.h"

// Prototype
static	BOOL		main_Init(HWND);
static	BOOL		main_Exit(PSSTATE);
static	BOOL		main_GetCommandLine(PSSTATE);
static	BOOL		main_Paint(PSSTATE,HDC);
VOID	CALLBACK	main_TimerProc(HWND,UINT,UINT,DWORD);

/******************************************************************************
|	
|-------+-------------------+--------------------------------------------------
|Entry	|hWnd				޳
|Return	|BOOL				ߒl
|Memo	|-
******************************************************************************/
static BOOL main_Init(
	HWND			hWnd
){
	LPSSTATE		pState;
	HWND			hDesktop;
	HGLOBAL			hMem;
	HDC				hDC;
	HBITMAP			hBitmap;
	int				iTime;
	RECT			rcRc;
	BOOL			bRes;

	// 
	hMem = GlobalAlloc(GPTR,sizeof(SSTATE));
	if (hMem == NULL) {
		return(FALSE);
	}
	SetWindowLong(hWnd,GWL_USERDATA,(long)hMem);
	pState = (PSSTATE)hMem;
	pState->hWnd = hWnd;
	pState->hInst = (HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE);
	GetLocalTime(&pState->stStartTime);
	srand((UINT)pState->stStartTime.wMilliseconds);
	// ײ݉
	main_GetCommandLine(pState);
	// 
	util_GetSysInfo(hWnd);
	// 񏉊
	pState->soOption.bScrDelete = FALSE;
	pState->soOption.hScrDelBrush = (HBRUSH)GetStockObject(BLACK_BRUSH);
	// ذݕۑ
	hDesktop = GetDesktopWindow();
	if (pState->bPreview == TRUE) {
		hDesktop = hWnd;
	}
	GetClientRect(hDesktop,&rcRc);
	hDC = GetDC(hDesktop);
	if (hDC != NULL) {
		pState->hSaveDC = CreateCompatibleDC(hDC);
		if (pState->hSaveDC != NULL) {
			hBitmap = CreateCompatibleBitmap(hDC,
				GetRectWidth(&rcRc) - 1,GetRectHeight(&rcRc) - 1);
			if (hBitmap != NULL) {
				pState->hSaveBmp = hBitmap;
				pState->hSaveBmpOld = (HBITMAP)SelectObject(pState->hSaveDC,hBitmap);
				BitBlt(pState->hSaveDC,0,0,
					GetRectWidth(&rcRc) - 1,GetRectHeight(&rcRc) - 1,
					hDC,0,0,SRCCOPY);
			}
		}
		pState->hWorkDC = CreateCompatibleDC(hDC);
		hBitmap = CreateCompatibleBitmap(hDC,
			GetRectWidth(&rcRc) - 1,GetRectHeight(&rcRc) - 1);
		if (hBitmap != NULL) {
			pState->hWorkBmp = hBitmap;
			pState->hWorkBmpOld = (HBITMAP)SelectObject(pState->hWorkDC,hBitmap);
			BitBlt(pState->hWorkDC,0,0,
				GetRectWidth(&rcRc) - 1,GetRectHeight(&rcRc) - 1,
				hDC,0,0,SRCCOPY);
		}
		ReleaseDC(hWnd,hDC);
	}
	// ϰݒ
	iTime = APP_TIMER;
	pState->uFrameTimeID = SetTimer(hWnd,APP_FRAME_TIMER_ID,iTime,
		(TIMERPROC)main_TimerProc);
	pState->dwFrame = 0;
	// հް
	bRes = app_Init(pState);
	if (bRes == FALSE) {
		main_Exit(pState);
		return(FALSE);
	}

	return(TRUE);
}

/******************************************************************************
|	I
|-------+-------------------+--------------------------------------------------
|Entry	|pState				Ǘ
|Return	|BOOL				ߒl
|Memo	|-
******************************************************************************/
static BOOL main_Exit(
	PSSTATE			pState
){
	BOOL			bRes;

	if (pState != NULL) {
		return(FALSE);
	}
	if (pState->bPreview != TRUE) {
		if (pState->soOption.bEnableSound == TRUE) {
		}
	}
	// I
	bRes = app_Exit(pState);
	SetWindowLong(pState->hWnd,GWL_USERDATA,(long)NULL);
	KillTimer(pState->hWnd,pState->uFrameTimeID);
	if (pState->hSaveDC != NULL) {
		DeleteDC(pState->hSaveDC);
	}
	if (pState->hWorkDC != NULL) {
		DeleteDC(pState->hWorkDC);
	}
	SelectObject(pState->hSaveDC,pState->hSaveBmpOld);
	DeleteObject(pState->hSaveBmp);
	DeleteDC(pState->hSaveDC);
	pState->hSaveBmp = NULL;
	pState->hSaveDC = NULL;
	SelectObject(pState->hWorkDC,pState->hWorkBmpOld);
	DeleteObject(pState->hWorkBmp);
	DeleteDC(pState->hWorkDC);
	pState->hWorkBmp = NULL;
	pState->hWorkDC = NULL;
	if (pState != NULL) {
		GlobalFree((HGLOBAL)pState);
	}

	return(TRUE);
}

/******************************************************************************
|	`
|-------+-------------------+--------------------------------------------------
|Entry	|pState				Ǘ
|		|hDC				޲÷
|Return	|BOOL				ߒl
|Memo	|pState->iFrame𗘗p
******************************************************************************/
static BOOL main_Paint(
	PSSTATE			pState,
	HDC				hDrawDC
){
	PSAPPINFO		paInfo;
	RECT			rcDraw;

	// 
	paInfo = pState->papInfo;
	if (pState->bPreview == TRUE) {
	}
	GetClientRect(pState->hWnd,&rcDraw);
	app_Paint(pState,pState->hWorkDC,&rcDraw);
	// I
	BitBlt(hDrawDC,0,0,GetRectWidth(&rcDraw) - 1,GetRectHeight(&rcDraw) - 1,
		pState->hWorkDC,0,0,SRCCOPY);

	return(TRUE);
}

/******************************************************************************
|	ײ݉
|-------+-------------------+--------------------------------------------------
|Entry	|pState				Ǘ
|Return	|BOOL				ߒl
|Memo	|-
******************************************************************************/
static BOOL main_GetCommandLine(
	LPSSTATE		pState
){
	TCHAR			cChr;
	int				iLen;
	int				lp;

	pState->bPreview = FALSE;
	pState->lpctstrCmdLine = GetCommandLine();
	iLen = lstrlen(pState->lpctstrCmdLine);
	for(lp = 0;lp < iLen;lp++) {
		cChr = pState->lpctstrCmdLine[lp];
		if(cChr == '/') {
			if (pState->lpctstrCmdLine[lp + 1] == 'p') {
				pState->bPreview = TRUE;
				return(TRUE);
			}
		}
	}

	return(FALSE);
}

/******************************************************************************
|	ʳ޳׽쐬
|-------+-------------------+--------------------------------------------------
|Entry	|hInst				ݽݽ
|Return	|BOOL				ߒl
|Memo	|-
******************************************************************************/
BOOL WINAPI RegisterDialogClasses(
	HANDLE			hInst
){
	return(TRUE);
}

/******************************************************************************
|	ۼެ
|-------+-------------------+--------------------------------------------------
|Entry	|hWnd				޳
|		|iMsg				ү
|		|wParam				
|		|lParam				
|Return	|BOOL				ߒl
|Memo	|-
******************************************************************************/
LONG WINAPI ScreenSaverProc(
	HWND			hWnd,
	UINT			iMsg,
	WPARAM			wParam,
	LPARAM			lParam
){ 
	PSSTATE			pState;
	HDC				hDC;
	RECT			rcRc;
	PAINTSTRUCT		psPs;
	BOOL			bRes;

	// Ǘ擾
	pState = (PSSTATE)GetWindowLong(hWnd,GWL_USERDATA);
	switch(iMsg){
		case WM_CREATE:
			bRes = main_Init(hWnd);
			if(bRes == FALSE) {
				return(-1);
			}
			return(0);
		case WM_ERASEBKGND:
			if (pState != NULL) {
				hDC = (HDC)wParam;
				if (pState->soOption.bScrDelete == TRUE) {
					GetClientRect(hWnd,&rcRc);
					FillRect(hDC,&rcRc,pState->soOption.hScrDelBrush);
				}
				return(-1);
			}
			return(0);
		case WM_PAINT:
			hDC = BeginPaint(hWnd,&psPs);
			main_Paint(pState,hDC);
			EndPaint(hWnd,&psPs);
			return(0);
		case WM_DESTROY:
			main_Exit(pState);
			return(0);
	}
	return(DefScreenSaverProc(hWnd,iMsg,wParam,lParam));
}

/******************************************************************************
|	ϰĂяo
|-------+-------------------+--------------------------------------------------
|Entry	|hWnd				޳
|		|iMsg				WM_TIMER
|		|iID				ʔԍ
|		|dwSysTime			
|Return	|-					-
|Memo	|-
******************************************************************************/
VOID CALLBACK main_TimerProc(
	HWND			hWnd,
	UINT			iMsg,
	UINT			iID,
	DWORD			dwSysTime
){
	PSSTATE			pState;

	// Ǘ擾
	pState = (PSSTATE)GetWindowLong(hWnd,GWL_USERDATA);
	// Frame Count Time
	if (APP_FRAME_TIMER_ID == iID) {
		InvalidateRect(hWnd,NULL,FALSE);
		pState->dwFrame++;
	}
}












