/******************************************************************************
|Project	|Windows SDI Application Skelton Sorce
|Copyright	|Copyright(C)1997-1999 Kazuhiko Watanabe
|-----------+---------------+--------------------------------------------------
|content	|Ҳ ͯ
|			|necessary "SCRNSAVE.LIB" with "WINMM.LIB" Liblary
|-----------+---------------+--------------------------------------------------
|Renewal	|1997/10/09		Kazuhiko Watanabe
|			|1999/05/24		Version up
|			|19--/--/--		-
|			|19--/--/--		-
******************************************************************************/
#ifndef __MAIN_H__

#include	"misc.h"

/******************************************************************************
|	Application infomation
******************************************************************************/
#define		APP_NAME			TEXT("WSCRASV")
#define		APP_TIMER			(400)
#define		APP_FRAME_TIMER_ID	(256)
#define		APP_INI_FILE		TEXT("wscrsv.ini")
//
#define		MAX_DRIVE			(32)
#define		MAX_WORK			(32)

/******************************************************************************
|	Struct define
******************************************************************************/
// Screen Saver Application Infomation
typedef struct _tSS_AppInfo{
	DWORD			dwFlag;						// Flag
	// user define..
}SAPPINFO,*LPSAPPINFO,*PSAPPINFO;

// Option Status Struct
typedef struct _tSS_Option{
	BOOL			bScrDelete;					// Start Up To Screen Fill
	HBRUSH			hScrDelBrush;				// Screen Fill Pattern
	BOOL			bEnableSound;				// Enabled Sound
}SOPTION,*LPSOPTION,*PSOPTION;

// Disk Infomation Status Struct
typedef struct _tSS_DiskInfo{
	BOOL			bLongFileName;				// Long Filename Saport
	TCHAR			szVolLabel[MAX_STR];		// Disk Volume Label Name
	TCHAR			szFileSysName[MAX_STR];		// Disk Format of File System Name
	int				iDriveType;					// Drive Type
	DWORD			dwDiskSpace;				// Disk All Space
	DWORD			dwDiskFreeSpace;			// Disk Free Space
}SDISKINFO,*LPSDISKINFO,*PSDISKINFO;

// System Infomation Status Struct
typedef struct _tSS_SysInfo{
	TCHAR			szUserName[MAX_STR];		// Login User Name
	TCHAR			szComputerName[MAX_STR];	// PowerOn Computer Name
	TCHAR			szCurrentDirPath[MAX_PATH];	// Current Directory Path
	TCHAR			szWindowsDirPath[MAX_PATH];	// Windows Directory Path
	TCHAR			szSystemDirPath[MAX_PATH];	// Windows System Directory Path
	int				iScreenWidth;				// Desktop Screen Width Size
	int				iScreenHeight;				// Desktop Screen Height size
	int				iScreenBPP;					// Video Device Screen Mode
	BOOL			bPresentMouse;				// Can Use Mouse Flag
	DWORD			dwProcessorType;			// CPU Type
	DWORD			dwTotalMemSize;				// Total Memory Size
	DWORD			dwMemSize;					// Free Memory Size
	DWORD			dwTotalVirtualMemSize;		// Total Virtual Memory Size
	DWORD			dwVirtualMemSize;			// Virtual Memory Size
	BOOL			bPowerStatus;				// "psPowerStatus" Enable Flag
	SYSTEMTIME		stSystemTime;				// System Time
	SYSTEMTIME		stLocalTime;				// Local Time
	SYSTEM_POWER_STATUS	psPowerStatus;			// PowerSystem
	SDISKINFO		diDrive[MAX_DRIVE];			// Disk Infomation
	OSVERSIONINFO	ovOSVersion;				// OS Version Struct
}SSYSINFO,*LPSSYSINFO,*PSSYSINFO;

// Screen Saver Status Struct
typedef struct _tSS_State{
	HWND			hWnd;						// Widnow handle
	HINSTANCE		hInst;						// Screen Saver Instance Handle
	LPCTSTR			lpctstrCmdLine;				// Command Line
	BOOL			bPreview;					// Preview Mode
	UINT			uFrameTimeID;				// Timer Event Handle
	DWORD			dwFrame;					// Event Call Counter
	HDC				hSaveDC;					// Save DeskTop
	HBITMAP			hSaveBmp;					// Save DeskTop Bitmap handle
	HBITMAP			hSaveBmpOld;				// Save DeskTop Bitmap handle
	HDC				hWorkDC;					// Work DC
	HBITMAP			hWorkBmp;					// Work Bitmap handle
	HBITMAP			hWorkBmpOld;				// Work Bitmap handle
	SYSTEMTIME		stStartTime;				// Local Time
	SSYSINFO		siSysInfo;					// System Infomation Struct
	SOPTION			soOption;					// Option Switch Struct
	PSAPPINFO		papInfo;					// Application Struct
}SSTATE,*LPSSTATE,*PSSTATE;

// Object Status (User Struct)
typedef struct _tSObject{
	BOOL			bUse;						// Use Flag
	POINT			ptPos;						// Position
	int				iWork[MAX_WORK];			// Work Area
}SOBJECT,*LPSOBJECT,*PSOBJECT;

#define	__MAIN_H__
#endif