/******************************************************************************
|Project	|Windows Application Common
|Copyright	|Copyrighted 1997-1999 (C)Kazuhiko Watanabe
|-----------+------------------------------------------------------------------
|Renewal	|1998/09/08		Kazuhiko Watanabe
|			|19--/--/--		-
|			|19--/--/--		-
|			|19--/--/--		-
******************************************************************************/
#ifndef		__MISC_H__
#pragma		pack(8)

/******************************************************************************
|	Common Constant
******************************************************************************/
#ifndef		_DEF_MISC_COMMON_
#define		MAX_STR					(256)
#define		MAX_SSTR				(64)
#define		NULL_STR				TEXT("")
#define		MAX_BYTE				((BYTE)0xff)
#define		MAX_WORD				((WORD)0xffff)
#define		MAX_DWORD				((DWORD)0xffffffff)
#define		BIT_0					(0x0001)
#define		BIT_1					(0x0002)
#define		BIT_2					(0x0004)
#define		BIT_3					(0x0008)
#define		BIT_4					(0x0010)
#define		BIT_5					(0x0020)
#define		BIT_6					(0x0040)
#define		BIT_7					(0x0080)
#define		BIT_8					(0x0100)
#define		BIT_9					(0x0200)
#define		BIT_10					(0x0400)
#define		BIT_11					(0x0800)
#define		BIT_12					(0x1000)
#define		BIT_13					(0x2000)
#define		BIT_14					(0x4000)
#define		BIT_15					(0x8000)
#define		MATH_PI					(DOUBLE)((DOUBLE)4 * (DOUBLE)atan(1))
#define		MATH_RAD360				(MATH_PI / (DOUBLE)180)
#define		_DEF_MISC_COMMON_
#endif

/******************************************************************************
|	Devicecontext Comon Constant
******************************************************************************/
#ifndef		_DEF_MISC_COMMON_DC_
#define		RGB_BLACK				(0x00000000)
#define		RGB_WHITE				(0x00ffffff)
#define		RGB_LTGRAY				(0x00c0c0c0)
#define		RGB_GRAY				(0x00808080)
#define		RGB_DKGRAY				(0x00404040)
#define		RGB_RED					(0x000000ff)
#define		RGB_GREEN				(0x0000ff00)
#define		RGB_BLUE				(0x00ff0000)
#define		RGB_LTRED				(0x008080ff)
#define		RGB_LTGREEN				(0x0080ff80)
#define		RGB_LTBLUE				(0x00ff8080)
#define		RGB_DKRED				(0x000000a0)
#define		RGB_DKGREEN				(0x0000a000)
#define		RGB_DKBLUE				(0x00a00000)
#define		RGB_YELLOW				(0x0000ffff)
#define		RGB_PURPLE				(0x00ff00ff)
#define		RGB_SKYBLUE				(0x00ffff00)
#define		RGB_SKIN				(0x00a0e0ff)
#define		_DEF_MISC_COMMON_DC_
#endif

/******************************************************************************
|	Common Macro
******************************************************************************/
// en1:LPPOINT	en2:int		en3:int
#define		SetPoint(en1,en2,en3)	\
	{((LPPOINT)en1)->x = en2;((LPPOINT)en1)->y = en3;}
// en1:LPRECT	en2:int		en3:int
#define		OffsetPoint(en1,en2,en3)	\
	{((LPPOINT)en1)->x += en2;((LPPOINT)en1)->y += en3;}
// en1:LPRECT
#define		GetRectWidth(en1)		\
	((((LPRECT)en1)->right - ((LPRECT)en1)->left) + 1)
// en1:LPRECT
#define		GetRectHeight(en1)		\
	((((LPRECT)en1)->bottom - ((LPRECT)en1)->top) + 1)
// en1:LPRECT	en2:LPPOINT
#define		GetRectCenter(en1,en2)	\
	(en2->x = (GetRectWidth(en1) / 2);en2->y = (GetRectHeight(en1) / 2);)
// en1:LPRECT	en2:int		en3:int
#define		ResizeRect(en1,en2,en3)		\
	{((LPRECT)en1)->left += en2;((LPRECT)en1)->right -= en2;\
	((LPRECT)en1)->top += en3;((LPRECT)en1)->bottom -= en3;}
#define		bitEasyReset(en1,en2)	(en1) &=~ (1 << (en2))
#define		bitEasyGet(en1,en2)		(((en1) & (1 << (en2))) >> (en2))
#define		bitEasySet(en1,en2)		(en1) |= (1 << (en2))
#define		bitReset(en1,en2)		(en1) &= (~(en2))
#define		bitGet(en1,en2)			((en1) & (en2))
#define		bitSet(en1,en2)			(en1) |= (en2)

#pragma		pack()
#define		__MISC_H__
#endif